	import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics2D;
import java.awt.event.KeyEvent;
import java.awt.image.BufferedImage;
import java.util.ArrayList;
import java.util.Iterator;

import com.golden.gamedev.Game;
import com.golden.gamedev.object.PlayField;
import com.golden.gamedev.object.Sprite;
import com.golden.gamedev.object.SpriteGroup;
/*
 * Created on 2004. 7. 30.
 *
 * All right reserved to Jisung, Ahn
 */

/**
 * 
 *
 * @author Jisung, Ahn
 *
 * 
 */
public class Sample extends Game {

	private BufferedImage _img;
	private Sprite _playerSprite;
    private ArrayList _bullets;
    private PlayField _playField;
    private SpriteGroup _playerGroup;
    private SpriteGroup _bulletGroup;
    private SpriteGroup _enemyGroup;
    private long _lastShoot;

	/* (non-Javadoc)
	 * @see com.golden.gamedev.Game#initResources()
	 */
	public void initResources() {
		_img = getImage("img/Character01.gif");
		
		_playerSprite = new Sprite(_img, 100,100);
		_bullets = new ArrayList();
		_playField = new PlayField();
		_playerGroup = _playField.addGroup(new SpriteGroup("Player"));
		_playerGroup.add(_playerSprite );		
		_bulletGroup = _playField.addGroup(new SpriteGroup("Bullet"));
		_enemyGroup = _playField.addGroup(new SpriteGroup("Enemy"));
		
		setFPS(60);
	}

	/* (non-Javadoc)
	 * @see com.golden.gamedev.Game#update()
	 */
	public void update() {		
		_playField.update();
        moveUser();
        shootBullet();
        moveBullet();
	}

	/**
     * 
     */
    private void moveBullet() {
        synchronized(_bullets){
            Sprite[] buls = (Sprite[]) _bullets.toArray(new Sprite[_bullets.size()]);
            
	        for (int i = 0; i < buls.length; i++) {
	            buls[i].moveX(5);
	            if (buls[i].getX() > 640 ){
	                _bulletGroup.remove(buls[i]);
	                _bullets.remove(buls[i]);
	            }
            }
	            
        }
        
    }

    /**
     * 
     */
    private void shootBullet() {
        long current= System.currentTimeMillis();
        if (! keyDown(KeyEvent.VK_CONTROL) || _bullets.size() >= 5 || current < _lastShoot+300){
            return;
        }
        _lastShoot  = current;
        System.out.println("shootBullet");
        Sprite b = new Sprite(getImage("img/Bullet01.gif"), _playerSprite.getX()+100, _playerSprite.getY()+60);
        _bulletGroup.add(b);
        synchronized(_bullets){
            _bullets.add(b);
        }
        
        
        
    }

    /**
     *
     */
    private void moveUser() {
        if (keyDown(KeyEvent.VK_LEFT))  _playerSprite.moveX(-4);
        if (keyDown(KeyEvent.VK_RIGHT)) _playerSprite.moveX(4);
        if (keyDown(KeyEvent.VK_UP))    _playerSprite.moveY(-4);
        if (keyDown(KeyEvent.VK_DOWN))  _playerSprite.moveY(4);
    }

    /* (non-Javadoc)
	 * @see com.golden.gamedev.Game#render(java.awt.Graphics2D)
	 */
	public void render(Graphics2D g) {
		g.setColor(Color.LIGHT_GRAY);
        g.fillRect(0, 0, getWidth(), getHeight());
//        _playerSprite.render(g);
        _playField.render(g);
        

	}

	public static void main(String[] args) {
		Sample game = new Sample();
		game.setup(new Dimension(640, 480), false);
		game.start();
	}
}
