import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

import com.golden.gamedev.Game;

public class Play extends JFrame implements ActionListener {

	public Play() {
		super("Choose Sample to Play");

		JPanel pane = (JPanel) getContentPane();
		pane.setLayout(new GridLayout(0, 1));

		for (int i=0;i < 4;i++) {
			JButton btn = new JButton("Run Sample "+(i+1));
			btn.addActionListener(this);
			pane.add(btn);
		}
	}

	public void actionPerformed(ActionEvent e) {
		int num = Integer.parseInt(e.getActionCommand().substring(11));
		Game game = null;

		switch (num) {
			case 1:
				game = new Sample1();
				game.setup(new Dimension(310, 248), false);
			break;

			case 2:
				game = new Sample2();
				game.setup(new Dimension(310, 248), false);
			break;

			case 3:
				game = new Sample3();
				game.setup(new Dimension(310, 248), false);
			break;

			case 4:
				game = new Sample4();
				game.setup(new Dimension(640, 480), true);
			break;
		}

		game.start();
	}

	public static void main(String[] args) {
		JFrame frame = new Play();
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.setSize(250, 250);
		frame.setLocationRelativeTo(null);
		frame.setResizable(false);
		frame.setVisible(true);
	}

}