package gamrprj;

import java.awt.geom.Rectangle2D;
import java.util.ArrayList;

/**
 * <p>Title: 2D  ùķ̼</p>
 * <p>Description:  Ʈ 2D   ǽð  ùķ̼ ǥ ϰ ֽϴ.  帮ڸ, Ͽ Ȩ  ǽðȭϴ  ǥԴϴ.  </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author Jisung, AHn
 * @version 1.0
 */

public class Galaxy extends Thread {
    static final Entity[] ENTITY_ARRAY = new Entity[0];
	int frameGap = 100;
    double _width;
    double _height;

    boolean _isExist = true;

	long frame = 0;
    ArrayList _entities;
    ArrayList _listeners;

	private static Galaxy _instance;

	public static Galaxy getInstance(double aWidth, double aHeight) {
		if (_instance == null ) {
			_instance = new Galaxy(aWidth, aHeight);
		}
		return _instance;
	}

	public static Galaxy getInstance() {
		return _instance;
	}

    private Galaxy(double aWidth, double aHeight) {
        _width = aWidth;
        _height = aHeight;
        _entities = new ArrayList();
        _listeners = new ArrayList();

    }

    public double getHeight() {
    	return _height;
    }
    public double getWidth() {
    	return _width;
    }

    public void addGameEventListener(GameEventListener listener) {
    	_listeners.add(listener);
    }
    public void removeGameEventListener(GameEventListener listener) {
    	_listeners.remove(listener);
    }

    public void addEntity(Entity entity) {
        _entities.add(entity);
    }
    public void removeEntity(Entity entity) {
        _entities.remove(entity);
    }


    public Entity[] getEntities() {
    	return (Entity[]) _entities.toArray(ENTITY_ARRAY);
    }


    public void run() {
        while(_isExist) {
            long frameStart = System.currentTimeMillis();

			doEitnty();

            throwEvent(new NewFrameEvent(this, frame));

            long frameEnd = System.currentTimeMillis();
            long gap = frameEnd - frameStart;
            if ( frameEnd - frameStart < frameGap) {
                try {
                    Thread.sleep(frameEnd - frameStart);
                }
                catch (InterruptedException ex) {
                }
            }
            frame++;
        }

    }

	void doEitnty() {
		for(int i=0; i < _entities.size();i++) {
		    Entity e = (Entity) _entities.get(i);
		    e.execute();
		}
	}

    private void throwEvent(GameEvent e) {

		for(int i=0; i<_listeners.size();i++) {
			((GameEventListener) _listeners.get(i)).eventOccured(e);
		}
    }

    public BattleField getBattleFieldOn(double x, double y, double aW, double aH) {
		double ax = x - aW/2;
		if (ax < 0) {
			ax = 0;
		}
		double ay =y - aH/2;
		if (ay < 0) {
			ay = 0;
		}
		Rectangle2D rect = new Rectangle2D.Double(ax, ay, aW, aH);
		ArrayList list = new ArrayList();
		for(int i=0; i < _entities.size();i++) {

		    Entity e = (Entity) _entities.get(i);
		    if (rect.contains(e.getPosition())) {
		    	list.add(e);
		    }
		}

		BattleField bf = new BattleField(rect,(Entity[]) list.toArray(new Entity[0]));
		return bf;

    }

}