package gamrprj;

import java.awt.BasicStroke;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.Shape;
import java.awt.geom.Line2D;
import java.awt.geom.Point2D;
import java.util.ArrayList;

import javax.swing.JFrame;

/**
 * @author Administrator
 *
 */
public class MainScreenFrame
    extends JFrame
    implements Runnable {
    Thread trdMyThread; // ø  \

    Galaxy galaxy;

    Image imgOffScr; // ޸ ۷  Image
    Graphics2D grpOffScr; // ޸  Graphics ڵ
    ControlFrame control;//*Frame;
    Line2D line;

    int t = 2;
    CollisionEngine collisionEngine;

    AbstractEntity ship;
    Color[] colors = new Color[] { Color.blue, Color.cyan, Color.darkGray, Color.green, Color.magenta, Color.pink};
    boolean isExist = true;
    int frameGap = 100;
    ArrayList _entities;
    ScreenPanel screenPanel = new ScreenPanel(600,600);
    public MainScreenFrame() {
        init();
        try {
            jbInit();
        }
        catch(Exception e) {
            e.printStackTrace();
        }
    }
    public void addEntity(Entity entity) {
        _entities.add(entity);
    }
    public void removeEntity(Entity entity) {
        _entities.remove(entity);
    }

    private void init() {
         _entities = new ArrayList();
        collisionEngine = new CollisionEngine();
        ship = new SampleShip("SampleShip",150, 200, 0, 1,100, 100);
        addEntity(ship);

//        controlFrame = new ControlFrame(ship, this);
//        controlFrame.setSize(new Dimension(200, 150));
//        controlFrame.setVisible(true);
//        controlFrame.setLocation(0, 700);

        line = new java.awt.geom.Line2D.Double(new Point2D.Double(0, 0),
                                               new Point2D.Double(500, 500));

        if (trdMyThread == null)
            trdMyThread = new Thread(this);
//        imgOffScr = new BufferedImage(600, 600, BufferedImage.TYPE_INT_RGB);

//        grpOffScr = (Graphics2D) imgOffScr.getGraphics();

        grpOffScr = screenPanel.getOffScreenGraphics();
        this.setSize(new Dimension(600, 600));

        this.setVisible(true);
        this.setLocation(0,0);

        trdMyThread.start();
    }

    public void run() {
        while (isExist) {
            long frameStart = System.currentTimeMillis();
            for (int i = 0; i < _entities.size(); i++) {
                Entity e = (Entity) _entities.get(i);
                e.execute();
            }
            repaint();
//            controlFrame.refreshInfo();

            long frameEnd = System.currentTimeMillis();
            long gap = frameEnd - frameStart;
            if (frameEnd - frameStart < frameGap) {
                try {
                    Thread.sleep(frameEnd - frameStart);
                }
                catch (InterruptedException ex) {
                }
            }

        }
    }

    public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g;

        // ޸ ۸ İ 
        grpOffScr.setColor(Color.black);
        grpOffScr.fillRect(0, 0, 600, 600);

        // ޸ ۿ  ׸
        grpOffScr.setColor(Color.white);

        grpOffScr.setStroke(new BasicStroke( (float) 1));

        for (int i=0 ;i < _entities.size(); i++) {
            Entity entity = (Entity) _entities.get(i);
            Shape tShape = entity.getTransformedShape();
            ship.getTransformedShape();
            grpOffScr.draw(tShape);
        }
        Shape tShape = ship.getTransformedShape();
        grpOffScr.draw(tShape);
        grpOffScr.draw(line);

        Point2D[] pts = ship.getPoints();

        if (pts != null && pts.length > 1) {
            for (int i = 0; i < pts.length; i++) {
                grpOffScr.setStroke(new BasicStroke( (float) 5));
                grpOffScr.setColor(Color.yellow);
//                grpOffScr.drawString("" + i, (int) pts[i].getX(),
//                                     (int) pts[i].getY());
            }
        }

        Point2D[] linePts = collisionEngine.getPointsOnShape(line);
        Line2D[] lines = collisionEngine.getLinesOnShape(tShape);
        ArrayList list = new ArrayList();
        boolean isCollid = false;
        for (int i = 0; i < lines.length; i++) {
            Point2D p = collisionEngine.getCrossPoint(lines[i], line);
            if (p == null) {

            }
            else {
                isCollid = true;
//                grpOffScr.drawString("# " + i, (int) p.getX(), (int) p.getY());
                list.add(p);
            }
        }
        if (isCollid) {
//            grpOffScr.drawString("Collid!!! ", 200, 80);
            Point2D[] ps = (Point2D[]) list.toArray(new Point2D[0]);
            if (ps.length < 2) {
                if (ps.length == 1) {
                    grpOffScr.drawRect( (int) ps[0].getX(), (int) ps[0].getY(),
                                       5,5);
                }
            }
            else {
                for (int ct = 0; ct < ps.length - 1; ct++) {

                    Line2D li = new Line2D.Double(ps[ct], ps[ct + 1]);
                    grpOffScr.setStroke(new BasicStroke( (float) 5));
                    grpOffScr.setColor(colors[ct]);
                    grpOffScr.draw(li);
                    double len = collisionEngine.getLineLength(li);

//                    grpOffScr.drawString("Len:" + len, (int) li.getX1(),
//                                         (int) li.getY1() - 20);
                }
            }
        }


        // ϼ ׸ ȭ鿡 Ѹ
        screenPanel.repaint();
//        g.drawImage(imgOffScr, 0, 0, this);
    }

    void fire(AbstractEntity ship) {
//        Laser laser = new Laser(ship,this);
//        addEntity(laser);
    }

    public static void main(String[] args) {
        MainScreenFrame f = new MainScreenFrame();
    }
    private void jbInit() throws Exception {
        this.getContentPane().add(screenPanel, BorderLayout.CENTER);
    }

}