/**
 *  Copyright (C) 2001-2004 Connected Systems Inc. All rights reserved. This
 *  software is the confidential and proprietary information of Connected
 *  Systems Inc. ("Confidential Information").
 */

package net.narusas.game.eun1;

import java.awt.event.MouseEvent;

import net.narusas.game.framework.Unit;
import net.narusas.game.framework.event.UserCommand;
import net.narusas.game.framework.event.UserCommandListener;

/**
 * @author jsahn
 * 
 * $Log: Controller.java,v $
 * Revision 1.5  2004/06/10 16:30:47  narusas
 * *** empty log message ***
 *
 * Revision 1.4  2004/06/10 13:58:05  narusas
 * *** empty log message ***
 * Revision 1.3 2004/06/09 15:39:42 narusas *** empty
 * log message ***
 * 
 * Revision 1.2 2004/06/09 12:44:22 narusas *** empty log message *** Revision
 * 1.1 2004/06/09 04:42:55 narusas *** empty log message ***
 *  
 */
public class Controller implements PositionSelectionListener, UserCommandListener {
	
	private EunGame _game;
	private boolean _controlMode;
	private Unit _selectedUnit;
	private int _movingState;
	
	private static final int NONE = 0;
	private static final int SET_WAYPOINT = 1;
	private static final int ADD_WAYPOINT = 2;	
	

	/**
	 * @param game
	 */
	public Controller(EunGame game) {
		_game = game;
		_controlMode = false;
	}

	public boolean isControlMode() {
		return _controlMode;
	}

	public void setControlMode(boolean mode) {
		_controlMode = mode;
	}

	/**
	 * @return
	 */
	public Unit[] getSelectedUnit() {
		if (_selectedUnit != null) {
			return new Unit[]{_selectedUnit};
		}
		return null;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see net.narusas.game.eun1.PositionSelectionListener#pressed(int, int)
	 */
	public void pressed(String src, int x, int y, int button) {
		System.out.println("## Position Selected X:" + x + " Y:" + y);
		switch(button){
			case MouseEvent.BUTTON1:
				button1Clicked(src, x, y);
				break;
			case MouseEvent.BUTTON2:
				button2Clicked(src, x, y);
				break;
			case MouseEvent.BUTTON3:
				button3Clicked(src, x, y);
				break;
				
				
		}
		
		
	}

	/**
	 * @param src
	 * @param x
	 * @param y
	 */
	private void button3Clicked(String src, int x, int y) {
		if (_selectedUnit == null){
			return;
		}
		
		_selectedUnit.setWayPoint(x,y);
		
	}

	/**
	 * @param src
	 * @param x
	 * @param y
	 */
	private void button2Clicked(String src, int x, int y) {
		// TODO Auto-generated method stub
		
	}

	/**
	 * @param src
	 * @param x
	 * @param y
	 */
	private void button1Clicked(String src, int x, int y) {
		if (isMovingState()){
			_selectedUnit.addWayPoint(x,y);
			setMovingState(NONE);			
		}
		else {
			if (!"Field".equals(src)) {
				return;
			}
			_selectedUnit = _game.getUnitManager().getUnitAt(x, y);
			if (_selectedUnit != null) {
				System.out.println("## Unit Selected " + _selectedUnit);
			}
		}
		
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see net.narusas.game.framework.event.UserCommandListener#execute(net.narusas.game.framework.event.UserCommand)
	 */
	public void execute(UserCommand cmd) {
		System.out.println("## Command received :"+cmd.getData());
		switch (cmd.getData()) {
			case 'M' :
			case 'm' :
				if (_selectedUnit != null ){
					if (cmd.isShiftPressed()){
						setMovingState(ADD_WAYPOINT);
					}
					else {
						setMovingState(SET_WAYPOINT);
					}
					
				}
				
				break;
			default :
		}
	}

	/**
	 * @param newMode
	 *  
	 */
	private void setMovingState(int newMode) {
		_movingState = newMode;
	}

	public boolean isMovingState() {
		return _movingState == ADD_WAYPOINT || _movingState == SET_WAYPOINT;
	}


}