/*
 * Created on 2004. 6. 1.
 *
 * All right reserved to Jisung, Ahn
 */

package net.narusas.game.eun1;

import java.awt.Color;
import net.narusas.game.eun1.layers.BGLayer;
import net.narusas.game.eun1.layers.FieldLayer;
import net.narusas.game.eun1.layers.GridLayer;
import net.narusas.game.eun1.layers.MiniMapLayer;
import net.narusas.game.eun1.layers.SelectionMarkLayer;
import net.narusas.game.eun1.layers.UnitLayer;
import net.narusas.game.eun1.layers.WayPointLayer;
import net.narusas.game.eun1.units.CircleUnit;
import net.narusas.game.framework.Game;

/**
 * 
 * 
 * @author Jisung, Ahn
 * 
 *  
 */
public class EunGame extends Game {

	private BattleField _battleField;
	private Controller _controller;
	private UserCommandInputManager _commandManager;

	public EunGame() {
		super();
		int fieldWidth = 500;
		int fieldHeight = 500;
		
		_controller = new Controller(this);
		_battleField = new BattleField(5000, 5000, fieldWidth, fieldHeight, 0, 0);
		
		_commandManager = new UserCommandInputManager(this);
		getEventManager().addKeyListener(_commandManager);
		
		_commandManager.addUserCommandListener(_controller);		
		
		Color c = new Color(255, 0, 0, 100);
		getUnitManager().addUnit(new CircleUnit(300, 300, 15, 30f, 20f,Color.WHITE, c));
		getUnitManager().addUnit(new CircleUnit(200, 200, 10, 235f,40f, Color.WHITE, c));
		getUnitManager().addUnit(new CircleUnit(1200, 1200, 10, 180f,3f, Color.WHITE, c));
		_layerManager.addLayer(new BGLayer(this));
		
		FieldLayer fieldLayer = new FieldLayer(this, 0, 0, fieldWidth, fieldHeight);
		getEventManager().addMouseListener(fieldLayer);
		fieldLayer.addPositionSelectionListener(_controller);
		_layerManager.addLayer(fieldLayer);
		
		
		_layerManager.addLayer(new GridLayer(this, _battleField, 0, 0, fieldWidth, fieldHeight, 50));
		
		MiniMapLayer miniMapLayer = new MiniMapLayer(this, _battleField, 510, 0, 200, 200, 100);
		miniMapLayer.addPositionSelectionListener(_controller);
		_layerManager.addLayer(miniMapLayer);
		
		WayPointLayer wayPointLayer = new WayPointLayer (this, 0, 0, fieldWidth, fieldHeight); 
		_layerManager.addLayer(wayPointLayer);
		_layerManager.addLayer(new SelectionMarkLayer(this, _battleField, 0, 0, fieldWidth, fieldHeight));
		_layerManager.addLayer(new UnitLayer(this, _battleField, 0, 0, fieldWidth, fieldHeight));
		
	}

	public BattleField getBattleField() {
		return _battleField;
	}

	public Controller getController() {
		return _controller;
	}
}