/*
 * Created on 2004. 6. 9.
 *
 * All right reserved to Jisung, Ahn
 */
package net.narusas.game.eun1;

import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.util.ArrayList;

import net.narusas.game.framework.event.UserCommand;
import net.narusas.game.framework.event.UserCommandListener;

/**
 * 
 * 
 * @author Jisung, Ahn
 * 
 *  
 */
public class UserCommandInputManager implements KeyListener {

	private EunGame _game;
	private ArrayList _listeners;

	/**
	 * @param game
	 */
	public UserCommandInputManager(EunGame game) {
		_game = game;
		_listeners = new ArrayList();
	}

	public void addUserCommandListener(UserCommandListener listener) {
		_listeners.add(listener);
	}

	public void removeUserCommandListener(UserCommandListener listener) {
		_listeners.remove(listener);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.awt.event.KeyListener#keyPressed(java.awt.event.KeyEvent)
	 */
	public void keyPressed(final KeyEvent e) {
		System.out.println("# Key pressed");

		UserCommand cmd = new UserCommand() {

			public String getName() {
				return "KeyBoardInput";
			}

			public long getWhen() {
				return e.getWhen();
			}

			public char getData() {
				return e.getKeyChar();
			}

			public boolean isShiftPressed() {				
				return e.isShiftDown();
			}

		};
		for (int i = 0; i < _listeners.size(); i++) {
			UserCommandListener listener = (UserCommandListener) _listeners
					.get(i);
			listener.execute(cmd);
		}
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.awt.event.KeyListener#keyReleased(java.awt.event.KeyEvent)
	 */
	public void keyReleased(KeyEvent e) {
		// TODO Auto-generated method stub

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.awt.event.KeyListener#keyTyped(java.awt.event.KeyEvent)
	 */
	public void keyTyped(KeyEvent e) {
		// TODO Auto-generated method stub

	}
}