/**
 *  Copyright (C) 2001-2004 Connected Systems Inc. All rights reserved. This
 *  software is the confidential and proprietary information of Connected
 *  Systems Inc. ("Confidential Information").
 */

package net.narusas.game.eun1.layers;

import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.ArrayList;
import net.narusas.game.eun1.EunGame;
import net.narusas.game.eun1.PositionSelectionListener;
import net.narusas.game.framework.GraphicsUtils;
import net.narusas.game.framework.Layer;

/**
 * @author jsahn
 * 
 * $Log: FieldLayer.java,v $
 * Revision 1.5  2004/06/10 16:30:47  narusas
 * *** empty log message ***
 *
 * Revision 1.4  2004/06/09 12:44:22  narusas
 * *** empty log message ***
 * Revision 1.3 2004/06/06 15:56:14 narusas Unit
 * Manager Unit Layer ⺻  Ϸ Revision 1.2 2004/06/02 16:22:31 narusas ***
 * empty log message ***
 * 
 * Revision 1.1 2004/06/01 10:09:36 narusas *** empty log message ***
 *  
 */
public class FieldLayer implements Layer, MouseListener {

	private EunGame _game;
	private int _x;
	private int _y;
	private int _width;
	private int _height;
	private Rectangle _bounds;
	private ArrayList _listeners;

	public FieldLayer(EunGame game, int x, int y, int width, int height) {
		_game = game;
		_x = x;
		_y = y;
		_width = width;
		_height = height;
		_bounds = new Rectangle(x, y, width, height);
		_listeners = new ArrayList();
	}
	
	public void addPositionSelectionListener(PositionSelectionListener listener){
		_listeners.add(listener);		
	}
	
	public void removePositionSelectionListener(PositionSelectionListener listener){
		_listeners.remove(listener);		
	}
	/*
	 * (non-Javadoc)
	 * 
	 * @see net.narusas.game.framework.Layer#paint(java.awt.Graphics2D)
	 */
	public void paint(Graphics2D g2) {
		GraphicsUtils.drawBebelRect(g2, _x, _y, _width, _height);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see net.narusas.game.framework.Layer#getBounds()
	 */
	public Rectangle getBounds() {
		return _bounds;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.awt.event.MouseListener#mouseClicked(java.awt.event.MouseEvent)
	 */
	public void mouseClicked(MouseEvent e) {
		// TODO Auto-generated method stub
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.awt.event.MouseListener#mouseEntered(java.awt.event.MouseEvent)
	 */
	public void mouseEntered(MouseEvent e) {
		// TODO Auto-generated method stub
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.awt.event.MouseListener#mouseExited(java.awt.event.MouseEvent)
	 */
	public void mouseExited(MouseEvent e) {
		// TODO Auto-generated method stub
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.awt.event.MouseListener#mousePressed(java.awt.event.MouseEvent)
	 */
	public void mousePressed(MouseEvent e) {
		int x = e.getX();
		int y = e.getY();
		if ((x < _x) || (x > _x + _width) || (y < y) || (y > _y + _height)) {
			return;
		}
		Rectangle view = _game.getBattleField().getView();
		int px = view.x + x;
		int py = view.y + y;
		int button = e.getButton();
		
		
		for(int i=0; i < _listeners.size(); i++){
			((PositionSelectionListener)_listeners.get(i)).pressed("Field", px,py, button);
		}
		
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.awt.event.MouseListener#mouseReleased(java.awt.event.MouseEvent)
	 */
	public void mouseReleased(MouseEvent e) {
		// TODO Auto-generated method stub
	}
}