/**
 *  Copyright (C) 2001-2004 Connected Systems Inc. All rights reserved. This
 *  software is the confidential and proprietary information of Connected
 *  Systems Inc. ("Confidential Information").
 */
package net.narusas.game.eun1.layers;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Rectangle;

import net.narusas.game.eun1.BattleField;
import net.narusas.game.framework.Game;
import net.narusas.game.framework.Layer;

/**
 * @author jsahn
 * 
 * $Log: GridLayer.java,v $
 * Revision 1.4  2004/06/06 15:56:14  narusas
 * Unit Manager Unit Layer ⺻  Ϸ
 * Revision 1.3 2004/06/02 16:22:31 narusas *** empty
 * log message ***
 * 
 * Revision 1.2 2004/06/01 16:49:09 narusas *** empty log message ***
 * 
 * Revision 1.1 2004/06/01 10:09:36 narusas *** empty log message ***
 *  
 */
public class GridLayer implements Layer {
	private Game _game;
	private int _x;
	private int _y;
	private int _width;
	private int _height;
	private int _gridGap;
	private BattleField _battleField;
	private Rectangle _bounds;

	/**
	 * 
	 * @param game
	 * @param battleField
	 * @param x
	 * @param y
	 * @param width
	 * @param height
	 * @param gridGap
	 */
	public GridLayer(Game game, BattleField battleField, int x, int y,
			int width, int height, int gridGap) {
		_game = game;
		_battleField = battleField;
		_x = x;
		_y = y;
		_width = width;
		_height = height;
		_bounds = new Rectangle(x, y, width, height);
		_gridGap = gridGap;
	}
	/*
	 * (non-Javadoc)
	 * 
	 * @see net.narusas.game.framework.Layer#paint(java.awt.Graphics2D)
	 */
	public void paint(Graphics2D g2) {
		Rectangle view = _battleField.getView();
		int gapX = (int) (_gridGap - view.getX() % _gridGap);
		int gapY = (int) (_gridGap - view.getY() % _gridGap);

		g2.setColor(Color.GRAY);

		int x = 0;
		while (true) {
			g2.drawLine(_x + gapX + x, _y + 1, _x + gapX + x, _y + _height - 1);
			x += _gridGap;
			if (x >= _width) {
				break;
			}
		}

		int y = 0;
		while (true) {
			g2.drawLine(_x + 1, _y + gapY + y, _x + _width - 1, _y + gapY + y);
			y += _gridGap;
			if (y >= _height) {
				break;
			}
		}

	}
	/*
	 * (non-Javadoc)
	 * 
	 * @see net.narusas.game.framework.Layer#getBounds()
	 */
	public Rectangle getBounds() {
		return _bounds;
	}

}