/**
 *  Copyright (C) 2001-2004 Connected Systems Inc. All rights reserved. This
 *  software is the confidential and proprietary information of Connected
 *  Systems Inc. ("Confidential Information").
 */

package net.narusas.game.eun1.layers;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.ArrayList;
import net.narusas.game.eun1.BattleField;
import net.narusas.game.eun1.EunGame;
import net.narusas.game.eun1.PositionSelectionListener;
import net.narusas.game.framework.GraphicsUtils;
import net.narusas.game.framework.Layer;
import net.narusas.game.framework.Unit;

/**
 * @author jsahn
 * 
 * $Log: MiniMapLayer.java,v $
 * Revision 1.9  2004/06/10 16:30:47  narusas
 * *** empty log message ***
 *
 * Revision 1.8  2004/06/09 15:39:42  narusas
 * *** empty log message ***
 *
 * Revision 1.7  2004/06/09 12:44:22  narusas
 * *** empty log message ***
 * Revision 1.6 2004/06/09 00:28:15 narusas ***
 * empty log message ***
 * 
 * Revision 1.5 2004/06/07 16:22:53 narusas ̴ϸʰ BattleField 콺 Ŭ  
 * 
 * Revision 1.4 2004/06/06 15:56:14 narusas Unit Manager Unit Layer ⺻  Ϸ
 * Revision 1.3 2004/06/02 16:22:31 narusas *** empty log message ***
 * 
 * Revision 1.2 2004/06/01 16:49:09 narusas *** empty log message ***
 * 
 * Revision 1.1 2004/06/01 10:09:36 narusas *** empty log message ***
 *  
 */
public class MiniMapLayer implements Layer, MouseListener {

	private EunGame _game;
	private int _x;
	private int _y;
	private int _width;
	private int _height;
	private int _gridGap;
	private BattleField _battleField;
	private float _xRatio;
	private float _yRatio;
	private float _xGap;
	private float _yGap;
	private Rectangle _bounds;
	private int _oldX;
	private int _oldY;
	private ArrayList _positionListener;

	public MiniMapLayer(EunGame game, BattleField battleField, int x, int y, int width, int height,
			int gridGap) {
		_game = game;
		_game.getEventManager().addMouseListener(this);
		_battleField = battleField;
		_x = x;
		_y = y;
		_width = width;
		_height = height;
		_bounds = new Rectangle(x, y, width, height);
		_gridGap = gridGap;
		_xRatio = ((float) _battleField.getWidth() / _width);
		_yRatio = ((float) _battleField.getHeight() / _height);
		_positionListener = new ArrayList();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see net.narusas.game.framework.Layer#paint(java.awt.Graphics2D)
	 */
	public void paint(Graphics2D g2) {
		//	    g2.setColor(Color.BLACK);
		//		g2.fillRect(_x,_y,_width,_height);
		Rectangle view = _battleField.getView();
		int x = (int) (_x + ((float) view.getX() / _xRatio));
		int y = (int) (_y + ((float) view.getY() / _yRatio));
		int width = (int) ((float) view.getWidth() / _xRatio);
		int height = (int) ((float) view.getHeight() / _yRatio);
		g2.setColor(Color.BLUE);
		g2.drawRect(x, y, width, height);
		g2.setColor(Color.RED);
		Unit[] units = _game.getUnitManager().getUnits();
		for (int i = 0; i < units.length; i++) {
			int ux = (int) (_x + ((float) units[i].getX() / _xRatio));
			int uy = (int) (_y + ((float) units[i].getY() / _yRatio));
			g2.drawRect(ux, uy, 1, 1);
		}
		GraphicsUtils.drawBebelRect(g2, _x, _y, _width, _height);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see net.narusas.game.framework.Layer#getBounds()
	 */
	public Rectangle getBounds() {
		return _bounds;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.awt.event.MouseListener#mouseClicked(java.awt.event.MouseEvent)
	 */
	public void mouseClicked(MouseEvent e) {
		// TODO Auto-generated method stub
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.awt.event.MouseListener#mouseEntered(java.awt.event.MouseEvent)
	 */
	public void mouseEntered(MouseEvent e) {
		// TODO Auto-generated method stub
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.awt.event.MouseListener#mouseExited(java.awt.event.MouseEvent)
	 */
	public void mouseExited(MouseEvent e) {
		// TODO Auto-generated method stub
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.awt.event.MouseListener#mousePressed(java.awt.event.MouseEvent)
	 */
	public void mousePressed(MouseEvent e) {		
//		if (_oldX == e.getX() && _oldY == e.getY()) {
//			return;
//		}
		if (e.getX() > _x && e.getX() < _x + _width && e.getY() > _y && e.getY() < _y + _height) {
			_oldX = e.getX();
			_oldY = e.getY();
			int viewX = (int) ((_oldX - _x) * _xRatio);
			int viewY = (int) ((_oldY - _y) * _yRatio);
			if ( e.getButton() == MouseEvent.BUTTON1){
				_game.getBattleField().viewAt(viewX, viewY);
			}
			else {
				int button = e.getButton();
				notifyPositionSelected(viewX, viewY, button);
			}
		}
	}

	/**
	 * @param button
	 * @param i
	 * @param j
	 */
	private void notifyPositionSelected(int x, int y, int button) {
		
		for (int i = 0; i < _positionListener.size(); i++) {
			((PositionSelectionListener) _positionListener.get(i)).pressed("MiniMap", x, y, button);
		}
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.awt.event.MouseListener#mouseReleased(java.awt.event.MouseEvent)
	 */
	public void mouseReleased(MouseEvent e) {
	}

	public void addPositionSelectionListener(PositionSelectionListener listener) {
		_positionListener.add(listener);
	}

	public void removePositionSelectionListener(PositionSelectionListener listener) {
		_positionListener.remove(listener);
	}
}