/**
 *  Copyright (C) 2001-2004 Connected Systems Inc. All rights reserved. This
 *  software is the confidential and proprietary information of Connected
 *  Systems Inc. ("Confidential Information").
 */

package net.narusas.game.eun1.layers;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import net.narusas.game.eun1.BattleField;
import net.narusas.game.eun1.Controller;
import net.narusas.game.eun1.EunGame;
import net.narusas.game.framework.Layer;
import net.narusas.game.framework.Unit;

/**
 * @author jsahn
 * 
 * $Log: SelectionMarkLayer.java,v $
 * Revision 1.1  2004/06/09 12:44:22  narusas
 * *** empty log message ***
 * Revision 1.1 2004/06/09 04:42:55 narusas ***
 * empty log message ***
 *  
 */
public class SelectionMarkLayer implements Layer {

	private EunGame _game;
	private BattleField _field;
	private int _x;
	private int _y;
	private int _width;
	private int _height;
	private Controller _controller;

	/**
	 * @param game
	 * @param field
	 * @param i
	 * @param j
	 * @param k
	 * @param l
	 */
	public SelectionMarkLayer(EunGame game, BattleField field, int x, int y, int width, int height) {
		_game = game;
		_field = field;
		_x = x;
		_y = y;
		_width = width;
		_height = height;
		_controller = _game.getController();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see net.narusas.game.framework.Layer#paint(java.awt.Graphics2D)
	 */
	public void paint(Graphics2D g2) {
		Unit[] selectedUnits = _controller.getSelectedUnit();
		if (selectedUnits == null) {
			return;
		}
		Rectangle view = _field.getView();
		for (int i = 0; i < selectedUnits.length; i++) {
			if (view.contains(selectedUnits[i].getBounds())) {
				drawSelection(g2, selectedUnits[i], view);
			}
		}
	}

	/**
	 * @param g2
	 * @param unit
	 * @param view
	 */
	private void drawSelection(Graphics2D g2, Unit unit, Rectangle view) {
		Rectangle bound = unit.getBounds();
		int cx = bound.x - (int) view.getX();
		int cy = bound.y - (int) view.getY();
		Color c = Color.GREEN;
		g2.setColor(c);
		g2.drawRect(cx, cy, bound.width, bound.height);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see net.narusas.game.framework.Layer#getBounds()
	 */
	public Rectangle getBounds() {
		return new Rectangle(_x, _y, _width, _height);
	}
}