/*
 * Created on 2004. 6. 7.
 *
 * All right reserved to Jisung, Ahn
 */
package net.narusas.game.eun1.layers;

import java.awt.Graphics2D;
import java.awt.Rectangle;

import net.narusas.game.eun1.BattleField;
import net.narusas.game.eun1.EunGame;
import net.narusas.game.framework.Layer;
import net.narusas.game.framework.Unit;
import net.narusas.game.framework.UnitManager;

/**
 * 
 * 
 * @author Jisung, Ahn
 * 
 *  
 */
public class UnitLayer implements Layer {

	private EunGame _game;
	private int _x;
	private int _y;
	private int _width;
	private int _height;
	private UnitManager _unitManager;
	private BattleField _battleField;
	private Unit[] _units;

	/**
	 * @param game
	 * @param field
	 * @param i
	 * @param j
	 * @param k
	 * @param l
	 */
	public UnitLayer(EunGame game, BattleField field, int x, int y, int width,
			int height) {
		_game = game;
		_unitManager = _game.getUnitManager();
		_battleField = field;
		_x = x;
		_y = y;
		_width = width;
		_height = height;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see net.narusas.game.framework.Layer#paint(java.awt.Graphics2D)
	 */
	public void paint(Graphics2D g2) {
		Rectangle view = _battleField.getView();
		_units = _unitManager.getUnits(view);
		for (int i = 0; i < _units.length; i++) {
			_units[i].draw(g2, view);
		}
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see net.narusas.game.framework.Layer#getBounds()
	 */
	public Rectangle getBounds() {		
		return new Rectangle(_x, _y, _width, _height);
	}

}