/**
 *  Copyright (C) 2001-2004 Connected Systems Inc. All rights reserved. This
 *  software is the confidential and proprietary information of Connected
 *  Systems Inc. ("Confidential Information").
 */

package net.narusas.game.eun1.layers;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.Rectangle;
import net.narusas.game.eun1.Controller;
import net.narusas.game.eun1.EunGame;
import net.narusas.game.framework.Layer;
import net.narusas.game.framework.Unit;

/**
 * @author jsahn
 * 
 * $Log: WayPointLayer.java,v $
 * Revision 1.1  2004/06/10 13:58:05  narusas
 * *** empty log message ***
 *
 */
public class WayPointLayer implements Layer {

	private int _x;
	private EunGame _game;
	private int _y;
	private int _width;
	private int _height;
	private Controller _controller;

	/**
	 * @param game
	 * @param i
	 * @param j
	 * @param k
	 * @param l
	 */
	public WayPointLayer(EunGame game, int x, int y, int width, int height) {
		_game = game;
		_x = x;
		_y = y;
		_width = width;
		_height = height;
		_controller = game.getController();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see net.narusas.game.framework.Layer#paint(java.awt.Graphics2D)
	 */
	public void paint(Graphics2D g2) {
		Unit[] units = _controller.getSelectedUnit();
		if (units == null || units.length == 0) {
			return;
		}
		for (int i = 0; i < units.length; i++) {
			Unit unit = units[i];
			drawWayPoint(g2, unit);
		}
	}

	/**
	 * @param g2
	 * @param unit
	 */
	private void drawWayPoint(Graphics2D g2, Unit unit) {
		Point wayPoint = unit.getNextWayPoint();
		if (wayPoint == null) {
			return;
		}
		Rectangle view = _game.getBattleField().getView();
//		if (!view.contains(wayPoint)) {
//			return;
//		}
		int cx = wayPoint.x - view.x;
		int cy = wayPoint.y - view.y;		
		g2.setClip(_x, _y, _width, _height);
		g2.setColor(Color.ORANGE);		
		g2.drawLine(unit.getX()- view.x, unit.getY()- view.y, cx,cy);
		g2.fillRect(cx - 3, cy - 3, 6, 6);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see net.narusas.game.framework.Layer#getBounds()
	 */
	public Rectangle getBounds() {
		return new Rectangle(_x, _y, _width, _height);
	}
}