/*
 * Created on 2004. 6. 7.
 *
 * All right reserved to Jisung, Ahn
 */

package net.narusas.game.framework;

import java.awt.Rectangle;
import java.util.ArrayList;
import net.narusas.game.eun1.units.CircleUnit;

/**
 * 
 * 
 * @author Jisung, Ahn
 * 
 *  
 */
public class UnitManager {

	ArrayList _units;
	private Game _game;

	/**
	 * @param game
	 */
	public UnitManager(Game game) {
		_game = game;
		_units = new ArrayList();
	}

	/**
	 * @param view
	 * @return
	 */
	public Unit[] getUnits(Rectangle view) {
		return (Unit[]) _units.toArray(new Unit[_units.size()]);
	}

	/**
	 * @param unit
	 */
	public void addUnit(CircleUnit unit) {
		_units.add(unit);
	}

	/**
	 * @return
	 */
	public Unit[] getUnits() {
		return (Unit[]) _units.toArray(new Unit[_units.size()]);
	}

	public Unit getUnitAt(int x, int y) {
		Unit nearst = null;
		int len = Integer.MAX_VALUE;
		for (int i = 0; i < _units.size(); i++) {
			Unit u = (Unit) _units.get(i);
			Rectangle r = u.getBounds();
			if (r.contains(x, y)) {
				int l = length(x, y, r.x, r.y);
				if (l < len){
					nearst = u;
					len = l;
				}
			}
		}
		return nearst;
	}

	/**
	 * @param x
	 * @param y
	 * @param x2
	 * @param y2
	 * @return
	 */
	private int length(int x, int y, int x2, int y2) {
		return Math.abs(x - x2) + Math.abs(y - y2);
	}

	/**
	 * 
	 */
	public void tick() {
		for (int i = 0; i < _units.size(); i++) {
			Unit u = (Unit) _units.get(i);
			u.execute();
		}			
	}
}