/*
 * Created on 2004. 5. 30.
 * 
 *  
 */
package net.narusas.game.framework.clock;

import java.util.ArrayList;

/**
 * @author Administrator
 * 
 *  
 */
public class Clock implements Runnable {

	Thread _ticker;

	int _sleepTime;

	public long _currentTickTime = 0;

	public long _lastTickTime = 0;

	public long _startTickTime = 0;

	public long _tickCount = 0;

	ArrayList _cws = new ArrayList();

	private boolean _isClosed;

	public Clock(int sleepTime) {
		_sleepTime = sleepTime;
	}

	public void addClockWatcher(ClockWatcher c) {
		_cws.add(c);
	}

	public void removeClockWatcher(ClockWatcher c) {
		_cws.remove(c);
	}

	public void start() {
		if (_ticker == null) {
			_ticker = new Thread(this);
		}
		_isClosed = false;
		_ticker.start();
		_startTickTime = _lastTickTime = _currentTickTime = System
				.currentTimeMillis();
	}

	public void stop() {
		if (_ticker != null) {
			_isClosed = true;
		}
		_ticker = null;
	}

	public void run() {
		while (!_isClosed) {
			_currentTickTime = System.currentTimeMillis();
			_tickCount++;

			int size = _cws.size();
			for (int i = 0; i < size; i++) {
				ClockWatcher c = (ClockWatcher) _cws.get(i);
				try {
					c.tick(this);
				} catch (Exception ex) {
					// Ignore
				}

			}
			_lastTickTime = _currentTickTime;
			long timeLeft = _sleepTime - System.currentTimeMillis()
					+ _currentTickTime;
			if (timeLeft > 0) {
				try {
					Thread.sleep(timeLeft);
				} catch (InterruptedException e) {
				}
			}
		}
		_ticker = null;
	}

	public long timeSinceLastTick() {
		return _currentTickTime - _lastTickTime;
	}

	public long getTickCount() {
		return _tickCount;
	}

}