/*
 * Created on 2004. 5. 30.
 *
 * All right reserved to Jisung, Ahn
 */
package net.narusas.game.framework.event;

import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.ArrayList;

import net.narusas.game.framework.Game;

/**
 * 
 * 
 * @author Jisung, Ahn
 * 
 *  
 */
public class EventManager implements KeyListener, MouseListener {
	ArrayList _keyListeners;
	ArrayList _mouseListeners;
	private Game _game;

	public EventManager(Game game) {
		_game = game;
		_keyListeners = new ArrayList();
		_mouseListeners = new ArrayList();
	}

	public void addKeyListener(KeyListener listener) {
		_keyListeners.add(listener);
	}

	public void removeKeyListener(KeyListener listener) {
		_keyListeners.remove(listener);
	}

	public void addMouseListener(MouseListener listener) {
		_mouseListeners.add(listener);
	}

	public void removeMouseListener(MouseListener listener) {
		_mouseListeners.remove(listener);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.awt.event.KeyListener#keyPressed(java.awt.event.KeyEvent)
	 */
	public void keyPressed(KeyEvent e) {
		System.out.println("Key pressed");
		for (int i = 0; i < _keyListeners.size(); i++) {
			KeyListener listener = (KeyListener) _keyListeners.get(i);
			listener.keyPressed(e);
		}

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.awt.event.KeyListener#keyReleased(java.awt.event.KeyEvent)
	 */
	public void keyReleased(KeyEvent e) {
		System.out.println("Key released");
		for (int i = 0; i < _keyListeners.size(); i++) {
			KeyListener listener = (KeyListener) _keyListeners.get(i);
			listener.keyReleased(e);
		}
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.awt.event.KeyListener#keyTyped(java.awt.event.KeyEvent)
	 */
	public void keyTyped(KeyEvent e) {
		System.out.println("Key Typed");
		for (int i = 0; i < _keyListeners.size(); i++) {
			KeyListener listener = (KeyListener) _keyListeners.get(i);
			listener.keyTyped(e);
		}

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.awt.event.MouseListener#mouseClicked(java.awt.event.MouseEvent)
	 */
	public void mouseClicked(MouseEvent e) {
		System.out.println("Mouse Clicked");
		for (int i = 0; i < _mouseListeners.size(); i++) {
			MouseListener listener = (MouseListener) _mouseListeners.get(i);
			listener.mouseClicked(e);
		}
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.awt.event.MouseListener#mouseEntered(java.awt.event.MouseEvent)
	 */
	public void mouseEntered(MouseEvent e) {
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.awt.event.MouseListener#mouseExited(java.awt.event.MouseEvent)
	 */
	public void mouseExited(MouseEvent e) {

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.awt.event.MouseListener#mousePressed(java.awt.event.MouseEvent)
	 */
	public void mousePressed(MouseEvent e) {
		System.out.println("Mouse Pressed");
		for (int i = 0; i < _mouseListeners.size(); i++) {
			MouseListener listener = (MouseListener) _mouseListeners.get(i);
			listener.mousePressed(e);
		}

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.awt.event.MouseListener#mouseReleased(java.awt.event.MouseEvent)
	 */
	public void mouseReleased(MouseEvent e) {
		System.out.println("Mouse Released");
		for (int i = 0; i < _mouseListeners.size(); i++) {
			MouseListener listener = (MouseListener) _mouseListeners.get(i);
			listener.mouseReleased(e);
		}
	}
}