/*
 * Created on 2004. 5. 16.
 *
 * 
 */
package net.narusas.game.framework.util;

/**
 * @author Jisung, Ahn
 * 
 *  
 */
public class EaseInOutInterpolation {
	private float _value;
	private float _target;
	private float _speed;
	private float _acceleration;
	private float _remainingTime;
	private float _totalTime;

	public boolean setup(float from, float to, float time) {
		if (time <= 0) {
			return false;
		}
		_value = from;
		_target = to;
		_speed = 0.0f;
		_acceleration = (to - from) / (time * time / 4);
		_remainingTime = time;
		_totalTime = time;
		return true;
	}

	public boolean interpolation(float deltaTime) {
		_remainingTime -= deltaTime;
		if (_remainingTime < _totalTime / 2) {
			_speed -= _acceleration * deltaTime;
		} else {
			_speed += _acceleration * deltaTime;
		}
		_value += _speed * deltaTime;
		return (_remainingTime <= 0);
	}

	public float getValue() {
		return _value;
	}

}