package net.narusas.game.tactical;

import java.awt.BasicStroke;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.geom.Line2D;
import java.awt.geom.Point2D;
import java.awt.image.BufferedImage;
import java.awt.image.VolatileImage;
import java.util.ArrayList;

import javax.swing.JFrame;

import net.narusas.game.tactical2.AbstractEntity;
import net.narusas.game.tactical2.CollisionEngine;
import net.narusas.game.tactical2.Entity;
import net.narusas.game.tactical2.SampleShip;
import net.narusas.game.tactical2.ScreenPanel;

/**
 * @author Administrator
 *  
 */
public class MainScreenFrame extends JFrame implements Runnable {

	Thread trdMyThread; // ø  \
	Galaxy galaxy;
	Image imgOffScr; // ޸ ۷  Image
	Graphics2D grpOffScr; // ޸  Graphics ڵ
	ControlFrame control;//*Frame;
	Line2D line;
	int t = 2;
	CollisionEngine collisionEngine;
	AbstractEntity ship;
	Color[] colors = new Color[]{Color.blue, Color.cyan, Color.darkGray,
			Color.green, Color.magenta, Color.pink};
	boolean isExist = true;
	int frameGap = 100;
	ArrayList _entities;
	ScreenPanel screenPanel = new ScreenPanel(600, 600);
	//  image creation
	VolatileImage vImg = createVolatileImage(600, 600);

	public MainScreenFrame() {
		init();
		try {
			jbInit();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public void addEntity(Entity entity) {
		_entities.add(entity);
	}

	public void removeEntity(Entity entity) {
		_entities.remove(entity);
	}

	private void init() {
		_entities = new ArrayList();
		collisionEngine = new CollisionEngine();
		ship = new SampleShip("SampleShip", 150, 200, 0, 1, 100, 100);
		addEntity(ship);
		//        controlFrame = new ControlFrame(ship, this);
		//        controlFrame.setSize(new Dimension(200, 150));
		//        controlFrame.setVisible(true);
		//        controlFrame.setLocation(0, 700);
		line = new java.awt.geom.Line2D.Double(new Point2D.Double(0, 0),
				new Point2D.Double(500, 500));
		if (trdMyThread == null)
			trdMyThread = new Thread(this);
		imgOffScr = new BufferedImage(600, 600, BufferedImage.TYPE_INT_RGB);
		grpOffScr = (Graphics2D) imgOffScr.getGraphics();
		grpOffScr = screenPanel.getOffScreenGraphics();
		this.setSize(new Dimension(600, 600));
		this.setVisible(true);
		this.setLocation(0, 0);
		trdMyThread.start();
	}

	public void run() {
		while (isExist) {
			long frameStart = System.currentTimeMillis();
			execute();
			repaint();
			//            controlFrame.refreshInfo();
			long frameEnd = System.currentTimeMillis();
			delayFrame(frameStart, frameEnd);
		}
	}

	/**
	 * @param frameStart
	 * @param frameEnd
	 */
	private void delayFrame(long frameStart, long frameEnd) {
		long gap = frameEnd - frameStart;
		if (frameEnd - frameStart < frameGap) {
			try {
				Thread.sleep(frameEnd - frameStart);
			} catch (InterruptedException ex) {
			}
		}
	}

	/**
	 *  
	 */
	private void execute() {
		for (int i = 0; i < _entities.size(); i++) {
			Entity e = (Entity) _entities.get(i);
			e.execute();
		}
	}

	void renderOffScreen() {
		do {
			//			if (vImg.validate(getGraphicsConfiguration()) ==
			// VolatileImage.IMAGE_INCOMPATIBLE) {
			//				// old vImg doesn't work with new GraphicsConfig; re-create it
			vImg = createVolatileImage(600, 600);
			//			}
			Graphics2D g = vImg.createGraphics();
			//
			// miscellaneous rendering commands...
			//
			g.setStroke(new BasicStroke(1.0f));
			g.setColor(Color.WHITE);
			g.drawRect(100, 100, 100, 120);
			g.dispose();
		} while (vImg.contentsLost());
	}

	public void paint(Graphics g) {
		//		GraphicsEnvironment ge =
		// GraphicsEnvironment.getLocalGraphicsEnvironment();
		//		GraphicsDevice[] gs = ge.getScreenDevices();
		Graphics2D g2 = (Graphics2D) g;
		//		do {
		//			GraphicsConfiguration[] gc = gs[0].getConfigurations();
		//			int returnCode = vImg.validate(gc[0]);
		//			if (returnCode == VolatileImage.IMAGE_RESTORED) {
		// Contents need to be restored
		renderOffScreen(); // restore contents
		//			}
		//			else if (returnCode == VolatileImage.IMAGE_INCOMPATIBLE) {
		// old vImg doesn't work with new GraphicsConfig; re-create it
		//				vImg = createVolatileImage(600, 600);
		//				renderOffScreen();
		//			}
		g2.drawImage(vImg, 0, 0, this);
		//		}
		//		while (vImg.contentsLost());
	}

	void fire(AbstractEntity ship) {
		//        Laser laser = new Laser(ship,this);
		//        addEntity(laser);
	}

	public static void main(String[] args) {
		MainScreenFrame f = new MainScreenFrame();
	}

	private void jbInit() throws Exception {
		this.getContentPane().add(screenPanel, BorderLayout.CENTER);
	}
}