/*
 * Created on 2004. 5. 22.
 * 
 * TODO To change the template for this generated file go to Window -
 * Preferences - Java - Code Generation - Code and Comments
 */
package net.narusas.game.tactical2;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.GraphicsConfiguration;
import java.awt.image.VolatileImage;
import java.util.ArrayList;

import javax.swing.JFrame;
import javax.swing.JPanel;

/**
 * @author Administrator
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Generation - Code and Comments
 */
public class MainScreenPanel extends JPanel implements Runnable {

	private int _width;

	private int _height;

	private VolatileImage _backBuffer;

	private Thread _thread;

	int step = 0;

	private ArrayList _entities;

	private CollisionEngine _collisionEngine;

	private SampleShip _ship;

	public MainScreenPanel() {

	}

	void init() {
		_entities = new ArrayList();
		_collisionEngine = new CollisionEngine();
		_ship = new SampleShip("SampleShip", 150, 200, 0, 1, 100, 100);
		addEntity(_ship);
	}

	public synchronized boolean initOffscreen() {
		if (_backBuffer == null || _width != getWidth()
				|| _height != getHeight()) {
			_width = getWidth();
			_height = getHeight();
			if (_width == 0 || _height == 0) {
				return false;
			}

			_backBuffer = createVolatileImage(_width, _height);

		}
		return true;
	}

	public void addEntity(Entity entity) {
		_entities.add(entity);
	}

	public void removeEntity(Entity entity) {
		_entities.remove(entity);
	}

	public void resetRestoreVolatileImages() {
		GraphicsConfiguration gc = this.getGraphicsConfiguration();

		int valCode = ((VolatileImage) _backBuffer).validate(gc);
		if (valCode == VolatileImage.IMAGE_INCOMPATIBLE) {
			_backBuffer = createVolatileImage(_width, _height);
		}

	}

	public void paint(Graphics g) {
		Graphics2D g2 = (Graphics2D) g;
		if (!initOffscreen()) {
			return;
		}

		// Render the back buffer and copy it to the screen. Loop until
		// the buffer contents are correct (this will only loop when/if
		// surface are lost, causing content loss on volatile images).
		try {
			do {
				resetRestoreVolatileImages();
				Graphics2D backG2 = (Graphics2D) _backBuffer.getGraphics();
				drawEntitis(backG2);
				backG2.dispose();
				g.drawImage(_backBuffer, 0, 0, this);
			} while (_backBuffer.contentsLost());
		} catch (Exception e) {
			System.out.println("Exception during paint: " + e);
		}
	}

	/**
	 * @param backG2
	 */
	private void drawEntitis(Graphics2D g2) {

		g2.setColor(Color.BLACK);
		g2.fillRect(0, 0, _width, _height);
		g2.setColor(Color.WHITE);
		for (int i = 0; i < 10; i++) {
			//            g2.fillRect(10+step+i*10, 10+step, 100, 200);
			g2.drawLine(i * 15, 0, i * 15, _height);
		}

		VolatileImage img = createVolatileImage(120, 200);
		Graphics2D ig2 = (Graphics2D) img.getGraphics();
		Color c = new Color(0f, 0f, 0f, 0f);

		ig2.setPaint(c);
		ig2.fillRect(0, 0, 100, 50);
		ig2.setColor(Color.red);
		ig2.fillRect(0, 0, 50, 50);

		g2.drawImage(img, 20, 20, this);

		if (step < 100) {
			step += 1;
		} else {
			step = 0;
		}

	}

	public void start() {
		_thread = new Thread(this);
		_thread.setPriority(Thread.MIN_PRIORITY);
		_thread.start();
	}

	public void run() {
		Thread me = Thread.currentThread();
		while (_thread == me) {
			Graphics g = getGraphics();
			update(g);
			g.dispose();
		}
		_thread = null;
	}

	public static void main(String[] args) {
		MainScreenPanel p = new MainScreenPanel();
		JFrame f = new JFrame("aaa");
		f.getContentPane().add(p);
		f.pack();
		f.setSize(new Dimension(800, 600));
		f.show();
		p.start();
	}
}